<!-- =========================================================================================
    File Name: VerticalNavMenuItem.vue
    Description: Vertical NavMenu item component. Extends vuesax framework's 'vs-sidebar-item' component
    Component Name: VerticalNavMenuItem
========================================================================================== -->

<template>
  <div
    v-if="canSee"
    class="vs-sidebar--item"
    :class="[
      { 'vs-sidebar-item-active': activeLink },
      { 'disabled-item pointer-events-none': isDisabled }
    ]"
    :style="cssProps"
  >
    <router-link
      tabindex="-1"
      v-if="to"
      exact
      :class="[{ 'router-link-active': activeLink }]"
      :to="to"
      :target="target"
    >
      <div v-if="!textIcon">
        <i v-if="!featherIcon" :class="[iconPack, 'mi-2x']">{{ icon }}</i>
        <feather-icon v-else :class="{ 'w-3 h-3': iconSmall }" :icon="icon" />
      </div>
      <div v-else class="text-icons">
        {{ icon }}
      </div>
      <slot />
    </router-link>

    <a v-else :target="target" :href="href" tabindex="-1">
      <div v-if="!textIcon">
        <i v-if="!featherIcon" :class="[iconPack, 'mi-2x']">{{ icon }}</i>
        <feather-icon v-else :class="{ 'w-3 h-3': iconSmall }" :icon="icon" />
        <slot />
      </div>
      <div v-else>
        <feather-icon :class="{ 'w-3 h-3': iconSmall }" icon="LayersIcon" />
      </div>
    </a>
  </div>
</template>

<script>
export default {
  name: "v-nav-menu-item",
  props: {
    icon: { type: String, default: "" },
    iconSmall: { type: Boolean, default: false },
    iconPack: { type: String, default: "material-icons" },
    iconColor: { type: String, default: "material-icons" },
    href: { type: [String, null], default: "#" },
    to: { type: [String, Object, null], default: null },
    slug: { type: String, default: null },
    index: { type: [String, Number], default: null },
    featherIcon: { type: Boolean, default: true },
    textIcon: { type: Boolean, default: false },
    target: { type: String, default: "_self" },
    isDisabled: { type: Boolean, default: false }
  },
  computed: {
    canSee() {
      this.$acl.check(this.$store.state.AppActiveUser.userRole);
      return this.to
        ? this.$acl.check(this.$router.match(this.to).meta.rule)
        : true;
    },
    activeLink() {
      return this.to == this.$route.path ||
        (this.$route.meta.parent == this.slug && this.to)
        ? true
        : false;
    },
    cssProps() {
      return {
        "--icon-color": this.iconColor
      };
    }
  }
};
</script>

<style lang="scss">
.vs-sidebar--item {
  .material-icons {
    -webkit-transition: border 0.25s ease;
    transition: border 0.25s ease;
    color: var(--icon-color);
    font-size: 1.5rem;
  }
  .text-icons {
    color: var(--icon-color);
  }
}
</style>
